{include file='include/colorbox.inc.tpl'}

{footer_script}{literal}
jQuery(document).ready(function(){
	jQuery(".createECardOpen").colorbox({
		inline:true,
		href:"#addECardForm",
		width:"50%",
		minWidth:"500px",
		height:"90%",
		onComplete:function(){
			jQuery("input[name=ecard_subject]").focus();
		}
	});

	jQuery("#addECardForm form").submit(function(){
		//jQuery(".createECardOpen").colorbox.close();
	});
});

function ecard_clearDefaultText(element, defaultText) {
	if (element.value == defaultText) {
		element.value = '';
	}
}

function ecard_checkField(element, elementType) {
	var TEXT = 0;
	var EMAIL = 1;
	
	switch (elementType) {
		case TEXT:
			if (element.value == '') {
				document.getElementById(element.id+'_error').innerHTML = "{'ecard_error'|@translate} {'ecard_error_text'|@translate}";
				element.className += " ecard_error_input";
				return false;
			} else {
				document.getElementById(element.id+'_error').innerHTML = '';
				element.className = element.className.replace( /(?:^|\s)ecard_error_input(?!\S)/g , '');
				return true;
			}
			break;
		case EMAIL:
			var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
			if (!filter.test(element.value)) {
				document.getElementById(element.id+'_error').innerHTML = "{'ecard_error'|@translate} {'ecard_error_email'|@translate}";
				element.className += " ecard_error_input";
				return false;
			} else {
				document.getElementById(element.id+'_error').innerHTML = '';
				element.className = element.className.replace( /(?:^|\s)ecard_error_input(?!\S)/g , '');
				return true;
			}
			break;
		default:
			return false;
			break;
	}
}

function ecard_checkForm(form) {
	var subjectOK = ecard_checkField(form.ecard_subject, 0);
	var messageOK = ecard_checkField(form.ecard_message, 0);
	var senderNameOK = ecard_checkField(form.ecard_sender_name, 0);
	var senderEMailOK = ecard_checkField(form.ecard_sender_email, 1);
	var recipientNameOK = ecard_checkField(form.ecard_recipient_name, 0);
	var recipientEMailOK = ecard_checkField(form.ecard_recipient_email, 1);
	
	if(subjectOK && messageOK && senderNameOK && senderEMailOK && recipientNameOK && recipientEMailOK)
		return true;
	else
		return false;
}
{/literal}{/footer_script}

<div style="display:none">
	<div id="addECardForm">
		<form method="post" onsubmit="return ecard_checkForm(this);">
			<fieldset>
				<legend>{'ecard_send_stage1'|@translate}</legend>
				<div class="ecard_field">
					<div class="ecard_error" id="ecard_subject_error"></div>
					<div class="ecard_error" id="ecard_message_error"></div>
					<span class="ecard_label">{'ecard_send_title'|@translate}<span class="ecard_mandatory_fields">*</span> :</span>
					<span class="ecard_input_right"><input name="ecard_subject" type="text" id="ecard_subject" value="{$ecard.subject}" onfocus="ecard_clearDefaultText(this, '{$ecard.subject}');" title="{$ecard.subject}"></span>
				</div>
				<div class="ecard_field">
					<span class="ecard_label">{'ecard_send_message'|@translate}<span class="ecard_mandatory_fields">*</span> :</span>
					<span class="ecard_input_right"><textarea name="ecard_message" id="ecard_message" value="{$ecard.message}" onfocus="ecard_clearDefaultText(this, '{$ecard.message}');" title="{$ecard.message}">{$ecard.message}</textarea></span>
				</div>
			</fieldset>
			<fieldset>
				<legend>{'ecard_send_stage2'|@translate}</legend>
				<div class="ecard_field">
					<div class="ecard_error" id="ecard_sender_name_error"></div>
					<div class="ecard_error" id="ecard_sender_email_error"></div>
					<span class="ecard_label">{'ecard_send_exp'|@translate}<span class="ecard_mandatory_fields">*</span> :</span>
					<span class="ecard_name"><input name="ecard_sender_name" type="text" id="ecard_sender_name" maxlength="100" value="{$ecard.sender_name}"></span>
					<span class="ecard_email"><input name="ecard_sender_email" type="text" id="ecard_sender_email" maxlength="100" {$ecard.changemail}  value="{$ecard.sender_email}" onfocus="ecard_clearDefaultText(this, '{$ecard.sender_email}');" onblur="ecard_checkField(this, 1);"></span>
				</div>
				<div class="ecard_field">
					<div class="ecard_error" id="ecard_recipient_name_error"></div>
					<div class="ecard_error" id="ecard_recipient_email_error"></div>
					<span class="ecard_label">{'ecard_send_dest'|@translate}<span class="ecard_mandatory_fields">*</span> :</span>
					<span class="ecard_name"><input name="ecard_recipient_name" type="text" id="ecard_recipient_name" maxlength="100" value="{$ecard.recipient_name}" onfocus="ecard_clearDefaultText(this, '{$ecard.recipient_name}');"></span>
					<span class="ecard_email"><input name="ecard_recipient_email" type="text" id="ecard_recipient_email" maxlength="100" value="{$ecard.recipient_email}" onfocus="ecard_clearDefaultText(this, '{$ecard.recipient_email}');" onblur="ecard_checkField(this, 1);"></span>
				</div>
			</fieldset>
			<fieldset>
				<legend>{'ecard_send_stage3'|@translate}</legend>
				<div class="ecard_field">
					<span class="ecard_label"><label for="ecard_copy">{'ecard_send_copy'|@translate} :</label></span>
					<span><input type="checkbox" id="ecard_copy" name="ecard_copy" {$ecard.copy}/></span>
				</div>
				<div class="ecard_field">
					<span class="ecard_label">{'ecard_send_method'|@translate} : </span>
						<span>
						{foreach from=$ecard_send_method item=ecard_send_method}
							<input type="radio" name="ecard_send_method" id="ecard_send_method_{$ecard_send_method.id}" value="{$ecard_send_method.id}" {$ecard_send_method.selected}><label for="ecard_send_method_{$ecard_send_method.id}">{$ecard_send_method.name} </label>
						{/foreach}
					</span>
				</div>
				{if isset($ecard_validity)}
					<div class="ecard_field">
						<span class="ecard_label">{'ecard_validity_label'|@translate} :</span>
						<span>
							{foreach from=$ecard_validity item=ecard_validity}
								<input type="radio" name="ecard_validity" id="ecard_validity_{$ecard_validity.id}" value="{$ecard_validity.id}" {$ecard_validity.selected}><label for="ecard_validity_{$ecard_validity.id}">{$ecard_validity.name} </label>
							{/foreach}
						</span>
					</div>
				{/if}
			</fieldset>
			<fieldset>
				<legend>{'ecard_send_stage4'|@translate}</legend>
				<div class="ecard_submit">
					<input type="submit" name="ecard_submit" value="{'ecard_send'|@translate}" />
				</div>
			</fieldset>
			<div>
				<span class="ecard_mandatory_fields">* {'ecard_send_mandatory_fields'|@translate}</span>
			</div>
		</form>
	</div>
</div>
<p>
	<a href="#" class="createECardOpen" title="{'ecard_send_link3'|@translate}">{'ecard_send_link1'|@translate}, {'ecard_send_link2'|@translate}</a>.
</p>